
--                     _oo0oo_
--                    088888880
--                    88" . "88
--                    (| -_- |)
--                     0\ = /0
--                  ___/'---'\___
--                .' \\\\|     |// '.
--               / \\\\|||  :  |||// \\
--              /_ ||||| -:- |||||- \\
--             |   | \\\\\\  -  /// |   |
--             | \_|  ''\---/''  |_/ |
--             \  .-\__  '-'  __/-.  /
--           ___'. .'  /--.--\  '. .'___
--        ."" '<  '.___\_<|>_/___.' >'  "".
--       | | : '-  \'.;'\ _ /';.'/ - ' : | |
--       \  \ '_.   \_ __\ /__ _/   .-' /  /
--   ====='-.____'.___ \_____/___.-'____.-'=====
--                     '=---='


-- ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
--           佛祖保佑    iii    永不出BUG

function __G__TRACKBACK__(errorMessage)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(errorMessage) .. "\n")
    print(debug.traceback("", 2))
    print("----------------------------------------")
end

local sharedApplication = CCApplication:sharedApplication()
local writablePath = CCFileUtils:sharedFileUtils():getWritablePath()
local filemgr = CCFileUtils:sharedFileUtils()
local target = sharedApplication:getTargetPlatform()
-- 检测版本文件控制情况
local function checkVersion(  )
	-- 将字符串内容读取为lua的table
	local function lua_do_string_main(str)
	    local fn = loadstring(str)
	    if(fn ~= nil) then
	        local retval = fn()
	        return retval
	    end
	    return nil
	end
	-- 获取版本号的数字
	local function getVerNum_main(version)
	    if not version then
	        return nil
	    end
	    local num = 0
	    for w in string.gmatch(version,"%d+") do     --迭代出所有的数字
	        num = num*10 + tonumber(w)
	    end
	    return num
	end
	--删除目录
	local function clean_dir_main(path)
		require("lfs")
	    for file in lfs.dir(path) do
	        if file ~= "." and file ~= ".." then
	            local fullpath = path..file
	            local attr = lfs.attributes (fullpath)
	            assert (type(attr) == "table")
	            if attr.mode == "directory" then
	                fullpath = fullpath.."/"
	                clean_dir_main(fullpath)
	                lfs.rmdir(fullpath)
	            else
	                os.remove(fullpath)
	            end
	        end
	    end
	end
	-- 获取res目录下的文件
	local verStr = CCFileUtils:sharedFileUtils():getFileData("res/version.txt")
    local installVer = nil
    if(verStr) then
    	installVer = lua_do_string_main(verStr)
    end
    -- 获取upd目录下的文件
    local updVer = nil
    local writablePath = CCFileUtils:sharedFileUtils():getWritablePath()
    local updDir = writablePath .. "upd/"
    local updVerPath = updDir .. "version.txt"
    if(CCFileUtils:sharedFileUtils():isFileExist(updVerPath)) then
    	local verStr1 = CCFileUtils:sharedFileUtils():getFileData(updVerPath)
    	if(verStr1) then
    		updVer = lua_do_string_main(verStr1)
    	end
    end
    -- 如果2者都存在的情况
    if(installVer and updVer) then
    	local bRemove = false
    	if(installVer.version and updVer.version) then
	    	print("包体："..installVer.version, "更新："..updVer.version)
	    	local ver1 = getVerNum_main(installVer.version)
	        local ver2 = getVerNum_main(updVer.version)
	        -- 如果包体中的版本号更大的话，清除数据
	        if(ver1 > ver2) then
	        	bRemove = true
	        end
	    end
	    -- 核心版本不一致
        if(installVer.core and updVer.core and tonumber(installVer.core)
        	~= tonumber(updVer.core)) then
        	bRemove = true
    	end
        -- 执行upd目录的清除行为
        if(bRemove) then
        	-- 执行目录的清除行为
			clean_dir_main(updDir)
        end
    end
end

if target == kTargetWindows then
	writablePath = string.gsub(writablePath, '\\', '/')
	filemgr:addSearchPath("res/")
else
	filemgr:addSearchPath(writablePath.."upd/")
	filemgr:addSearchPath("res/")
	-- 检测版本环境
	checkVersion()
	CCLuaLoadChunksFromZIP("update.bin")
end

print("重新载入update.bin")
-- 每次载入前都先滞空，重头开始
package.loaded["update.launcher"] = nil
-- 重新执行检测更新的方法
require "update.launcher"